<?php
class ebrowser_database {
private $PDO;
private $Information;
public function __construct () {
	if (!in_array ('sqlite', PDO::getAvailableDrivers ())) return (0);
	try {
		$this->PDO = new PDO ('sqlite:'.realpath (EBROWSER_PATH.$GLOBALS['DataDir'].'data_'.$GLOBALS['UniqueID'].'.sqlite'));
		}
	catch (Exception $e) {
		throw new Exception ();
		}
	}
public function location_exists ($Path) {
	return ((int) $this->PDO->query ('SELECT * FROM "locations" WHERE "path" = '.$this->PDO->quote ($Path))->fetchColumn ());
	}
public function location_array ($Path, $Refresh = 0) {
	if (!$Path) $Path = '/';
	else if ($Path[0] == '.') $Path = substr ($Path, 1);
	if (isset ($this->Information[$Path]) && !$Refresh) return ($this->Information[$Path]);
	$Pattern = array (
	'path' => &$Path,
	'trash' => 0,
	'description' => '',
	'icon' => '',
	'locked' => 0,
	'password' => '',
	'area' => '',
	'hidden' => 0,
	'preview' => 1,
	'hidesource' => 0,
	'counters' => 0,
	'ratings' => 1,
	'rating' => 0,
	'ratingsamount' => 0,
	'comments' => 0,
	'commentsamount' => 0,
	'views' => 0
	);
	$Parent = dirname ($Path);
	$Parent = (($Parent == '/')?'':$Parent).'/';
	if (!isset ($this->Information[$Parent]) && $Path != '/') $this->location_array ($Parent);
	$TmpArray = $this->PDO->query ('SELECT * FROM "locations" WHERE "path" = '.$this->PDO->quote ($Path))->fetchAll (PDO::FETCH_ASSOC);
	if (count ($TmpArray)) $this->Information[$Path] = array_merge ($Pattern, $TmpArray[0]);
	else {
		$this->Information[$Path] = $Pattern;
		if (!isset ($this->Information[$Parent])) return (0);
		foreach ($this->Information[$Parent] as $Key => $Value) {
			if (!in_array ($Key, array ('description', 'icon', 'path', 'views', 'rating', 'ratingsamount', 'commentsamount'))) $this->Information[$Path][$Key] = $Value;
			}
		}
	if (!$this->Information[$Path]['hidden']) $this->Information[$Path]['hidden'] = (($this->Information[$Path]['trash'] && !defined ('EBROWSER_ADMIN')) || substr (basename ($Path), 0, 1) == '.');
	$this->Information[$Path]['commentsamount'] = (int) $this->comments_amount ($Path);
	$this->Information[$Path]['locked'] = $this->Information[$Parent]['locked'];
	return ($this->Information[$Path]);
	}
public function location_update ($Path, $Array = 0) {
	if ($Path[0] == '.') $Path = substr ($Path, 1);
	if (!$Array) {
		$this->PDO->exec ('DELETE FROM "locations" WHERE "path" = '.$this->PDO->quote ($Path));
		$this->PDO->exec ('DELETE FROM "comments" WHERE "path" = '.$this->PDO->quote ($Path));
		$this->PDO->exec ('DELETE FROM "tags" WHERE "path" = '.$this->PDO->quote ($Path));
		if ($GLOBALS['RatingsTable']) $this->PDO->exec ('DELETE FROM "ratings" WHERE "path" = '.$this->PDO->quote ($Path));
		}
	else {
		$TmpArray = $this->location_array ($Path, 1);
		$TmpArray = array_merge ($TmpArray, $Array);
		if ($Path != $TmpArray['path']) {
			$this->PDO->exec ('UPDATE "comments" SET "path" = '.$this->PDO->quote ($TmpArray['path']).' WHERE "path" = '.$this->PDO->quote ($Path));
			$this->PDO->exec ('UPDATE "tags" SET "path" = '.$this->PDO->quote ($TmpArray['path']).' WHERE "path" = '.$this->PDO->quote ($Path));
			if ($GLOBALS['RatingsTable']) $this->PDO->exec ('UPDATE "ratings" SET "path" = '.$this->PDO->quote ($TmpArray['path']).' WHERE "path" = '.$this->PDO->quote ($Path));
			}
		$Query = array ();
		foreach ($TmpArray as $Key => $Value) {
			if (!in_array ($Key, array ('hidden', 'trash', 'ratingsamount', 'rating', 'views')) || isset ($Array[$Key])) $Query[$Key] = '"'.$Key.'" = '.$this->PDO->quote ($Value);
			}
		if (!$this->PDO->exec ('UPDATE "locations" SET '.implode (', ', $Query).' WHERE "path" = '.$this->PDO->quote ($Path))) {
			$this->PDO->exec ('INSERT INTO "locations" VALUES('.$this->PDO->quote ($TmpArray['path']).', \''.(int) $TmpArray['trash'].'\', '.$this->PDO->quote ($TmpArray['description']).', '.$this->PDO->quote ($TmpArray['icon']).', \''.(int) $TmpArray['locked'].'\', '.$this->PDO->quote ($TmpArray['password']).', '.$this->PDO->quote ($TmpArray['area']).', \''.(int) $TmpArray['preview'].'\', \''.(int)  $TmpArray['hidden'].'\', \''.(int) $TmpArray['hidesource'].'\', \''.(int) $TmpArray['counters'].'\', \''.(int) $TmpArray['ratings'].'\', \''.(int) $TmpArray['comments'].'\', \''.(int) $TmpArray['views'].'\', \''.(int) $TmpArray['rating'].'\', \''.(int) $TmpArray['ratingsamount'].'\')');
			}
		}
	$this->location_array ($Path, 1);
	}
public function history_search ($From = '', $To = '', $Path = '', $IP = '') {
	$Query = array ();
	if ($From) $Query[] = '"time" >= '.strtotime ($From);
	if ($To) $Query[] = '"time" <= '.strtotime ($To);
	if ($Path) $Query[] = '"path" = '.$this->PDO->quote ($Path);
	if ($IP) $Query[] = '"ip" >= '.$this->PDO->quote ($IP);
	return ($Query?' WHERE '.implode (' AND ', $Query):'');
	}
public function history_array ($Page = 1, $Search = '') {
	$Amount = $this->history_amount ();
	$PagesAmount = ceil ($Amount / 25);
	if ($Page < 1 || $Page > $PagesAmount) $Page = 1;
	return ($this->PDO->query ('SELECT * FROM "history"'.$Search.' ORDER BY "time" DESC LIMIT '.(($Page - 1) * 25).', 25')->fetchAll (PDO::FETCH_ASSOC));
	}
public function history_amount ($Search = '') {
	return ($this->PDO->query ('SELECT COUNT(*) FROM "history"'.$Search)->fetchColumn ());
	}
public function history_update ($Path) {
	$this->PDO->exec ('DELETE FROM "history" WHERE "time" < '.strtotime ('-'.$GLOBALS['History'].' days'));
	$this->PDO->exec ('INSERT INTO "history" VALUES('.$this->PDO->quote ($Path).', '.$_SERVER['REQUEST_TIME'].', '.$this->PDO->quote ($_SERVER['REMOTE_ADDR']).')');
	}
public function upload_array ($Path) {
	return ($this->PDO->query ('SELECT * FROM "upload" WHERE "path" = '.$this->PDO->quote ($Path))->fetchAll (PDO::FETCH_ASSOC));
	}
public function upload_update ($Path, $Array = 0) {
	$this->PDO->exec ('DELETE FROM "upload" WHERE "path" = '.$this->PDO->quote ($Path));
	for ($i = 0, $c = count ($Array); $i < $c; ++$i) $this->PDO->exec ('INSERT INTO "upload" VALUES('.$this->PDO->quote ($Path).', '.(int) $Array[$i][0].', '.$this->PDO->quote ($Array[$i][1]).', '.$this->PDO->quote ($Array[$i][2]).')');
	}
public function trash_array () {
	return ($this->PDO->query ('SELECT * FROM "locations" WHERE "trash"')->fetchAll (PDO::FETCH_ASSOC));
	}
public function comments_array ($Path, $ID = 0, $Page = 1) {
	if (!$ID) {
		$Amount = $this->comments_amount ($Path);
		$PagesAmount = ceil ($Amount / 10);
		if ($Page < 1 || $Page > $PagesAmount) $Page = 1;
		}
	$Array = $this->PDO->query ('SELECT * FROM "comments" WHERE "path" = '.$this->PDO->quote ($Path).(defined ('EBROWSER_ADMIN')?'':' AND "active" = 1').($ID?' AND "time" = '.(int) $ID:'').' ORDER BY "time" DESC'.($ID?'':' LIMIT '.(($Page - 1) * 10).', 10'))->fetchAll (PDO::FETCH_ASSOC);
	return (($ID && $Array)?reset ($Array):$Array);
	}
public function comments_amount ($Path) {
	return ((int) $this->PDO->query ('SELECT COUNT(*) FROM "comments" WHERE "path" = '.$this->PDO->quote ($Path))->fetchColumn ());
	}
public function comments_update ($Path, $ID = 0, $Array = 0) {
	if ($Path[0] == '.') $Path = substr ($Path, 1);
	if ($ID) {
		if ($Array) $Array = array_merge ($this->comments_array ($Path, $ID), $Array);
		$this->PDO->exec ('DELETE FROM "comments" WHERE "time" = '.(int) $ID.' AND "path" = '.$this->PDO->quote ($Path));
		}
	if ($Array) {
		$this->PDO->exec ('INSERT INTO "comments" VALUES('.$this->PDO->quote ($Path).', '.(int) $ID.', '.$this->PDO->quote ($Array['ip']).', '.$this->PDO->quote ($Array['useragent']).', '.$this->PDO->quote ($Array['author']).', '.$this->PDO->quote ($Array['url']).', '.$this->PDO->quote ($Array['content']).', '.(int) $Array['active'].')');
		}
	}
public function tags_amount ($Tag) {
	return ($this->PDO->query ('SELECT COUNT(*) FROM "tags" WHERE "tag" = '.$this->PDO->quote ($Tag))->fetchColumn ());
	}
public function tags_array ($Tag = '') {
	return ($this->PDO->query ('SELECT * FROM "tags"'.($Tag?' WHERE "tag" = '.$this->PDO->quote ($Tag):'').' ORDER BY "tag" ASC')->fetchAll (PDO::FETCH_ASSOC));
	}
public function tags_list ($Path = '') {
	$Array = $this->PDO->query ('SELECT DISTINCT "tag" FROM "tags"'.($Path?' WHERE "path" = '.$this->PDO->quote ($Path):''))->fetchAll (PDO::FETCH_NUM);
	for ($i = 0, $c = count ($Array); $i < $c; ++$i) $Array[$i] = &$Array[$i][0];
	return ($Array);
	}
public function tags_update ($Path, $Array = 0) {
	$this->PDO->exec ('DELETE FROM "tags" WHERE "path" = '.$this->PDO->quote ($Path));
	for ($i = 0, $c = count ($Array); $i < $c; ++$i) $this->PDO->exec ('INSERT INTO "tags" VALUES('.$this->PDO->quote ($Path).', '.$this->PDO->quote ($Array[$i]).')');
	}
public function tags_delete ($Tag) {
	$this->PDO->exec ('DELETE FROM "tags" WHERE "tag" = '.$this->PDO->quote ($Tag));
	}
public function views_update ($Path) {
	if (!$this->PDO->exec ('UPDATE "locations" SET "views" = "views" + 1 WHERE "path" = '.$this->PDO->quote ($Path))) {
		$Array = $this->location_array ($Path);
		$Array['views'] = 1;
		$this->location_update ($Path, $Array);
		}
	}
public function rating_update ($Path, $Rating) {
	$Rating = (int) $Rating;
	if ((!defined ('EBROWSER_ADMIN') && isset ($_SESSION['eBrowser']['rating']) && ($_SERVER['REQUEST_TIME'] - $_SESSION['eBrowser']['rating']) < 5) || $Rating < 0 || $Rating > 5 || !e_cookie_get ('cookie')) return (0);
	$Array = $this->location_array ($Path);
	$Rated = (e_cookie_get ('rating'.$Path) !== FALSE && $Array['ratingsamount']);
	$Remove = (!$Rating && $Rated);
	$_SESSION['eBrowser']['rating'] = $_SERVER['REQUEST_TIME'];
	e_cookie_set ('rating'.$Path, ($Remove?NULL:$Rating));
	if ($Rated) $Rating = ($Rating - e_cookie_get ('rating'.$Path));
	if ($GLOBALS['RatingsTable']) $this->PDO->exec ('INSERT INTO "ratings" VALUES('.$this->PDO->quote ($Path).', '.(int) $Rating.', '.$_SERVER['REQUEST_TIME'].', '.$this->PDO->quote ($_SERVER['REMOTE_ADDR']).')');
	if (!$Remove && !$Rating) return (1);
	if (!$this->PDO->exec ('UPDATE "locations" SET '.($Remove?'"ratingsamount" = "ratingsamount" - 1, ':($Rated?'':'"ratingsamount" = "ratingsamount" + 1, ')).'"rating" = "rating" + '.$Rating.' WHERE "path" = '.$this->PDO->quote ($Path))) {
		$Array['rating'] = $Rating;
		$Array['ratingsamount'] = 1;
		$this->location_update ($Path, $Array);
		}
	return (1);
	}
public function clean () {
	$Result = $this->PDO->query ('SELECT "path" FROM "locations"');
	while ($Path = $Result->fetch (PDO::FETCH_ASSOC)) {
		$FileSystem = e_file_system_model ($Path['path']);
		if (!$FileSystem->information ($Path['path'])) $this->PDO->exec ('DELETE FROM "locations" WHERE "location" = '.$this->PDO->quote ($Path['path']));
		}
	}
}
?>