<?php
function e_theme_parse ($Theme, $Array) {
	foreach ($Array as $Key => $Value) $Theme = str_replace ('{'.$Key.'}', $Value, $Theme);
	return ($Theme);
	}
function e_theme_switches ($Theme, $Array) {
	foreach ($Array as $Key => $Value) $Theme = preg_replace (
		array (
			'#<!--start:'.$Key.'-->(.*?)<!--end:'.$Key.'-->#si',
			'#<!--start:!'.$Key.'-->(.*?)<!--end:!'.$Key.'-->#si'
			),
		array (
			($Value?'\\1':''),
			($Value?'':'\\1'),
			),
		$Theme
		);
	return ($Theme);
	}
function e_announce ($Content, $Type) {
	return (e_theme_parse ($GLOBALS['Theme']['announcement'], array (
	'class' => $Type,
	'type' => e_i18n (ucfirst ($Type)),
	'content' => $Content
	)));
	}
function e_icon_path ($Icon, $Category = 'browser') {
	return ($GLOBALS['Theme']['datapath'].'share/icons/'.$GLOBALS['ThemeConfiguration']['Icons'].'/'.$Category.'/'.$Icon.'.png');
	}
function e_links ($Page, $Amount, $Path) {
	$Links = array ();
	if ($Amount < 2) return ('');
	$Array = array (
		'first' => '&#060;&#060;',
		'previous' => '&#060;',
		'next' => '&#062;',
		'last' => '&#062;&#062;'
		);
	$TmpArray = array_merge (array (
		'first' => 1,
		'previous' => ($Page - 1)
		),
	range (($Page - (($Page == 5)?4:3)), ($Page + (($Page == ($Amount - 4))?4:3))),
	array (
		'next' => ($Page + 1),
		'last' => $Amount
		));
	foreach ($TmpArray as $Key => $Value) {
		if (is_numeric ($Key)) $Key = $Value;
		if (!is_numeric ($Key) || ($Key > 0 && $Key <= $Amount)) {
			if ($Value > 0 && $Value <= $Amount && $Value != $Page) $Links[] = '<a href="'.str_replace ('{page}', $Value, $Path).'" tabindex="'.(++$GLOBALS['TabIndex']).'" title="'.e_i18n ('Go to'.(is_numeric ($Key)?'':' '.$Key).' page').' '.(is_numeric ($Key)?$Value.'.':'('.$Value.'.)').'">'.(is_numeric ($Key)?$Key:$Array[$Key]).'</a>';
			else $Links[] = '<strong>'.(is_numeric ($Key)?$Key:$Array[$Key]).'</strong>';
			if (($Page > 4 && $Key == 'previous' && $Page != 5) || ($Page < ($Amount - 3) && $Key == ($Page + 3) && $Page != ($Amount - 4) )) $Links[] = '...';
			}
		}
	return ('<div class="links">
'.implode ('
|
', $Links).'
</div>
');
	}
function e_rating_widget ($Path, $Amount, $Mark = 0) {
	$RoundMark = round ($Mark);
	$Page = '';
	$ID = uniqid (md5 (mt_rand (0, 1000000)));
	for ($i = 1; $i < 6; ++$i) $Page.= '<a href="{path}'.$Path.'{separator}rating='.$i.'" tabindex="'.(++$GLOBALS['TabIndex']).'"'.($GLOBALS['ThemeConfiguration']['JavaScript']?' onclick="scriptLoad (\'{path}'.$Path.'{separator}request&amp;rating='.$i.'&amp;id=rating_'.$ID.'\', 0); return false"':'').' rel="nofollow">
<img src="'.e_icon_path ('rating', 'miscellaneous').'" alt="'.$i.'" id="rating_'.$ID.'_'.$i.'"'.(($RoundMark && $RoundMark >= $i)?' class="mark"':'').($GLOBALS['ThemeConfiguration']['JavaScript']?' onmouseover="ratingWidget (\'rating_'.$ID.'\', '.$i.')"':'').' />
</a>
';
	if (e_cookie_get ('rating'.$Path) && $Mark) $Page.= '<a href="{path}'.$Path.'{separator}rating=0" tabindex="'.(++$GLOBALS['TabIndex']).'" '.($GLOBALS['ThemeConfiguration']['JavaScript']?'onclick="scriptLoad (\'{path}'.$Path.'{separator}request&amp;rating=0&amp;id=rating_'.$ID.'\', 0); return false"':'').' id="rating_'.$ID.'_0" class="delete" rel="nofollow">
<img src="'.e_icon_path ('delete', 'miscellaneous').'" alt="0" />
</a>
';
	return ('<span class="rating" id="rating_'.$ID.'"'.($GLOBALS['ThemeConfiguration']['JavaScript']?' onmouseout="ratingWidget (\'rating_'.$ID.'\', '.$RoundMark.')"':'').' title="'.e_i18n ('Rating').': '.($Mark?round ($Mark, 2):e_i18n ('None.')).($Amount?' ('.$Amount.')':'').((e_cookie_get ('rating'.$Path) && $Mark)?' '.e_i18n ('Your rating').': '.e_cookie_get ('rating'.$Path):'').'">
'.$Page.'</span>
');
	}
function e_tags_widget ($Path) {
	$Array = $GLOBALS['DB']->tags_list ($Path);
	if (!$Array) return ('');
	$Max = 0;
	for ($i = 0, $c = count ($Array); $i < $c; ++$i) {
		$Array[$i] = array ($Array[$i], $GLOBALS['DB']->tags_amount ($Array[$i]));
		if ($Array[$i][1] > $Max) $Max = &$Array[$i][1];
		}
	$Page = '';
	for ($i = 0, $c = count ($Array); $i < $c; ++$i) $Page.= '<a href="{path}tags:/'.urlencode ($Array[$i][0]).'" tabindex="'.(++$GLOBALS['TabIndex']).'" title="'.$Array[$i][1].'" class="tags_'.floor (($Array[$i][1] / $Max) * 20).'">'.htmlspecialchars ($Array[$i][0]).'</a>
';
	return ('<div class="tags">
'.$Page.'</div>
');
	}
function e_entries ($Path) {
	$Directories = $Files = array ();
	$FileSystem = e_file_system_model ($Path);
	$Entries = $FileSystem->entries ($Path);
	for ($i = 0, $c = count ($Entries); $i < $c; ++$i) {
		$Information = $FileSystem->information ($Entries[$i]);
		if (!$Information || !e_permissions ($Information, $FileSystem)) continue;
		if (!$Information['directory']) $GLOBALS['AllSize'] += $Information['size'];
		$Type = (($Information['directory'] && $_COOKIE['eBrowserSeparate'])?'Directories':'Files');
		$Entry = e_entry ($Information, $FileSystem, $_COOKIE['eBrowserView']);
		${$Type}[] = array (strtolower ($Information[$_COOKIE['eBrowserSortBy']]), $Entry);
		}
	if (!$Directories && !$Files) return (0);
	$Sort = ($_COOKIE['eBrowserSortDirection']?'':'r').'sort';
	$Sort ($Directories);
	$Sort ($Files);
	$GLOBALS['DirectoriesAmount'] = count ($Directories);
	$GLOBALS['FilesAmount'] = count ($Files);
	$Array = array_merge ($Directories, $Files);
	for ($i = 0, $c = count ($Array); $i < $c; ++$i) $Array[$i] = &$Array[$i][1];
	return ($Array);
	}
function e_entries_list ($Path, $Array = 0, $Short = 0) {
	$Directories = array ();
	$FileSystem = e_file_system_model ($Path);
	$Entries = $FileSystem->entries ($Path);
	for ($i = 0, $c = count ($Entries); $i < $c; ++$i) {
		$Information = $FileSystem->information ($Entries[$i]);
		if (!$Information || !$Information['browseable'] || !e_permissions ($Information, $FileSystem) || ($FileSystem->type () != 'local' && !$Information['directory']) || ($Information['broken'] && !$Information['directory'])) continue;
		if ($Information['type'] == 'archive') $Location = 'archive:'.$Information['path'];
		else $Location = &$Information['path'];
		if (isset ($Array[$Location])) $SubDirectory = &$Array[$Location];
		else $SubDirectory = '';
		if (!$Short) {
			if ($FileSystem->type () == 'local' && !$Information['broken'] && $_COOKIE['eBrowserPreview']) $Thumbnail = e_entry_thumbnail ($Information, $FileSystem);
			else $Thumbnail = '';
			$Emblems = e_entry_emblems ($Information, $FileSystem);
			$Summary = e_entry_summary ($Information, $FileSystem, $Thumbnail, $Emblems);
			}
		$ID = 'location_'.md5 ($Information['path']);
		$Directories[] = array (strtolower ($Information['name']), '<li>
'.($Short?'':'<img src="'.$Information['icon'].'" alt="'.$Information['type'].'" id="'.$ID.'_icon" title="'.e_i18n ('Show / hide').'" onclick="'.(($SubDirectory && (defined ('EBROWSER_ADMIN') || !$Information['locked']))?'':'if (document.getElementById(\''.$ID.'\').className) scriptLoad (\''.$GLOBALS['Theme']['path'].$GLOBALS['Theme']['separator'].'request&amp;locations='.urlencode ($Location).'&amp;id='.$ID.'\', 0); ').'directoryShowHide (\''.str_replace ('\'', '\\\'', $Location).'\', \''.$ID.'\');" />
'.e_entry_emblems ($Information, $FileSystem)).'<a href="'.$GLOBALS['Theme']['path'].$Location.'" tabindex="'.(++$GLOBALS['TabIndex']).'">
'.e_string_cut ($Information['name'], 25).'
</a>
'.($Short?'':'<div id="summary_entries_'.$ID.'" style="display:none;">
'.$Summary.'</div>
<script type="text/javascript">
Locations[\''.$ID.'\'] = \''.$Information['path'].'\';
</script>
').($Information['size']?'<ul'.($Short?'':' id="'.$ID.'"').($SubDirectory?'':' class="empty" style="display:none;"').'>
'.($SubDirectory?$SubDirectory:'<li></li>
').'</ul>
':'').'</li>
');
		}
	sort ($Directories);
	$String = '';
	for ($i = 0, $c = count ($Directories); $i < $c; ++$i) $String.= $Directories[$i][1];
	return (array ($Path => $String));
	}
function e_entry (&$Information, &$FileSystem, $View) {
	if (!e_permissions ($Information, $FileSystem)) return ('');
	if ($FileSystem->type () == 'local' && !$Information['broken'] && $_COOKIE['eBrowserPreview']) $Thumbnail = e_entry_thumbnail ($Information, $FileSystem);
	else $Thumbnail = '';
	$Emblems = e_entry_emblems ($Information, $FileSystem);
	if ($GLOBALS['ThemeConfiguration']['ShowTooltips'] || $GLOBALS['ThemeConfiguration']['UpdateSidebar']) $Summary = e_entry_summary ($Information, $FileSystem, $Thumbnail, $Emblems);
	$Link = (($Information['address'] && !$Information['link'])?$Information['address']:'{path}'.(e_file_archive ($Information['path'])?'archive:':'').$Information['path']);
	$ID = md5 ($Information['path']);
	$Page = '<'.(($View == 'detailed')?'tr':'div').' id="entry_'.$ID.'" class="entry"'.($GLOBALS['ThemeConfiguration']['UpdateSidebar']?' onclick="entrySelect (\''.$ID.'\')"':'').(($Information['trash'] || $View == 'tree' || !$GLOBALS['ThemeConfiguration']['JavaScript'])?'':' ondblclick="document.location = \''.$Link.'\'"').($GLOBALS['ThemeConfiguration']['ShowTooltips']?' onmouseover="tooltipDelay (\'tooltip_'.$ID.'\', 1)" onmouseout="tooltipDelay (\'tooltip_'.$ID.'\', 0)"':'').'>
';
	if ($Information['ratings'] && !$Information['trash']) $Rating = e_rating_widget ($Information['path'], $Information['ratingsamount'], $Information['rating']);
	else $Rating = '';
	$Common = e_string_cut ($Information['name'], 21);
	if (strlen ($Common) > 13 && $View == 'icons') $Common = wordwrap ($Common, 12, '<br />
', 1);
	$Common = '<a href="'.$Link.'" tabindex="'.(++$GLOBALS['TabIndex']).'">
'.$Common.'
</a>'.($GLOBALS['ThemeConfiguration']['JavaScript']?'
<script type="text/javascript">
EntriesAmount++;
Entries[\''.$ID.'\'] = new Object;
Entries[\''.$ID.'\'][\'number\'] = EntryNumber++;
Entries[\''.$ID.'\'][\'path\'] = \''.$Information['path'].'\';
Entries[\''.$ID.'\'][\'name\'] = \''.$Information['name'].'\';
Entries[\''.$ID.'\'][\'extension\'] = \''.$Information['extension'].'\';
Entries[\''.$ID.'\'][\'type\'] =  \''.$Information['type'].'\';
Entries[\''.$ID.'\'][\'time\'] = \''.date ('d M Y H:i:s', $Information['time']).'\';
Entries[\''.$ID.'\'][\'size\'] = '.(int) $Information['size'].';
Entries[\''.$ID.'\'][\'link\'] = '.(int) $Information['link'].';
Entries[\''.$ID.'\'][\'hidden\'] = '.(int) $Information['hidden'].';
Entries[\''.$ID.'\'][\'locked\'] = '.(int) $Information['locked'].';
Entries[\''.$ID.'\'][\'broken\'] = '.(int) $Information['broken'].';
Entries[\''.$ID.'\'][\'trash\'] = '.(int) ($Information['trash'] && $FileSystem->type () != 'trash').';
</script>':'').(($GLOBALS['ThemeConfiguration']['ShowTooltips'] || $GLOBALS['ThemeConfiguration']['UpdateSidebar'])?'
<div class="tooltip" id="tooltip_'.$ID.'" style="display:none;">
'.$Summary.'</div>':'');
	switch ($View) {
		case 'detailed':
		for ($i = 0, $c = count ($GLOBALS['DetailedColumns']); $i < $c; ++$i) {
			$Column = '';
			switch ($GLOBALS['DetailedColumns'][$i]) {
				case 'name':
				$Column = '<img src="'.$Information['icon'].'" alt="'.$Information['type'].'" title="'.$Information['information'].'"'.(($Information['hidden'] || ($Information['trash'] && $FileSystem->type () != 'trash'))?' class="hidden"':'').' />
'.$Emblems.$Common;
				break;
				case 'permissions':
				$Column = $Information[$GLOBALS['DetailedColumns'][$i]];
				break;
				case 'access':
				case 'time':
				case 'trash':
				$Column = ($Information[$GLOBALS['DetailedColumns'][$i]]?date ('d.m.Y H:i:s', $Information[$GLOBALS['DetailedColumns'][$i]]):'');
				break;
				case 'size':
				$Column = (($Information['directory'])?($Information['size']?sprintf (e_i18n ('%d elements'), $Information['size']):''):($Information['size']?e_size ($Information['size']):'-'));
				break;
				case 'type':
				$Column = $Information['information'];
				break;
				case 'owner':
				$Column = ($Information['owner']?$Information['owner'].($Information['group']?' ('.$Information['group'].')':''):'');
				break;
				case 'views':
				$Column = ($Information['counters']?$Information['views']:'');
				break;
				case 'comments':
				$Column = ($Information['comments']?$Information['commentsamount']:'');
				break;
				case 'rating':
				$Column = (($Information['ratings'] && !$Information['trash'])?trim (e_rating_widget ($Information['path'], $Information['ratingsamount'], $Information['rating']), "\r\n"):'');
				break;
				default:
				continue;
				}
			$Page.= '<td>
'.(($Column !== '')?$Column:'-').'
</td>
';
			}
		$Page.= '</tr>
';
		break;
		case 'tree':
		if (isset ($GLOBALS['TreeBranch']) && $GLOBALS['TreePath'] == $Information['path']) $SubDirectory = &$GLOBALS['TreeBranch'];
		else $SubDirectory = '';
		$Page.= '<img src="'.$Information['icon'].'" alt="" id="tree_'.$ID.'_icon"'.(($Information['directory'] || $Information['browseable'])?' title="'.e_i18n ('Show / hide').'" onclick="'.(($SubDirectory && (defined ('EBROWSER_ADMIN') || !$Information['locked']))?'':'if (document.getElementById(\'tree_'.$ID.'\').className) scriptLoad (\''.$GLOBALS['Theme']['path'].$GLOBALS['Theme']['separator'].'request&amp;locations='.urlencode ($Information['path']).'&amp;id=tree_'.$ID.'\', 0); ').'directoryShowHide (\''.str_replace ('\'', '\\\'', $Information['path']).'\', \'tree_'.$ID.'\');"':'').' />
'.$Emblems.$Common.'</div>
';
		$Page = '<li>
'.$Page.($Information['size']?'<ul id="tree_'.$ID.'"'.($SubDirectory?'':' class="empty" style="display:none;"').'>
'.($SubDirectory?$SubDirectory:'<li></li>
').'</ul>
':'').'</li>
';		break;
		case 'icons':
		$Page.= '<span class="icon">
<img src="'.($Thumbnail?$Thumbnail.'" class="preview':$Information['icon'].'" class="nopreview').(($Information['hidden'] || ($Information['trash'] && $FileSystem->type () != 'trash'))?' hidden':'').'" alt="" />
'.$Emblems.(($Thumbnail && $_COOKIE['eBrowserPreview'])?'<br />
<img src="'.$Information['icon'].'" class="fileicon" alt="" />
':'').'</span>
'.$Common.'</div>
';
		break;
		}
	return ($Page);
	}
function e_entry_summary (&$Information, &$FileSystem, &$Thumbnail, &$Emblems) {
	if ($FileSystem->type () == 'local' && !$Information['broken'] && $Information['type'] == 'image') $ImageSize = getimagesize ('.'.$Information['path']);
	else $ImageSize = 0;
	return ('<div>
<img src="'.($Thumbnail?$Thumbnail.'" class="preview':$Information['icon'].'" class="nopreview').'" alt="" />
'.$Emblems.'</div>
'.e_i18n ('Name').': <em>'.wordwrap ($Information['name'], 10, '&shy;', 1).($Information['hidden']?' ['.e_i18n ('Hidden').']':'').($Information['locked']?' ['.e_i18n ('Locked').']':'').(($Information['trash'] && $GLOBALS['Path'] != 'trash:/')?' ['.e_i18n ('Trash').']':'').'</em><br />
'.e_i18n ('Location').': <em>'.wordwrap ($Information['path'], 10, '&shy;', 1).'</em><br />
'.($Information['information']?''.e_i18n ('Type').': <em>'.$Information['information'].($Information['link']?' ['.e_i18n ('Link').']':'').($Information['broken']?' ['.e_i18n ('Broken').']':'').'</em><br />
':'').($Information['mime']?''.e_i18n ('MIME').': <em>'.wordwrap ($Information['mime'], 10, '&shy;', 1).'</em><br />
':'').($Information['directory']?''.e_i18n ('Entries amount').': <em>'.$Information['size'].'</em>':''.e_i18n ('Size').': <em>'.e_size ($Information['size'], 0).'</em>').'<br />
'.($Information['trash']?(($Information['path'] != 'trash:/')?''.e_i18n ('Deleted').': <em>'.date ('d.m.Y H:i:s', $Information['trash']).'</em><br />
':''):($Information['address']?''.e_i18n ('Address').': <em>'.wordwrap ($Information['address'], 10, '&shy;', 1).'</em><br />
':'').(defined ('EBROWSER_ADMIN')?($Information['permissions']?''.e_i18n ('Permissions').': <em>'.e_file_permissions ($Information['permissions']).'</em><br />
':'').($Information['owner']?''.e_i18n ('Owner').': <em>'.$Information['owner'].'</em><br />
':'').($Information['group']?''.e_i18n ('Group').': <em>'.$Information['group'].'</em><br />
':''):'').($Information['time']?''.e_i18n ('Modification').': <em>'.date ('d.m.Y H:i:s', $Information['time']).'</em><br />
':'').($Information['access']?''.e_i18n ('Last access').': <em>'.date ('d.m.Y H:i:s', $Information['access']).'</em><br />
':'').(($Information['type'] == 'image' && $ImageSize)?''.e_i18n ('Dimensions').': <em>'.$ImageSize[0].' x '.$ImageSize[1].'</em><br />
':'').(($GLOBALS['DB'] && $FileSystem->type () != 'trash')?($Information['counters']?''.e_i18n ('Views').': <em>'.$Information['views'].'</em><br />
':'').($Information['comments']?''.e_i18n ('Comments').': <em>'.$Information['commentsamount'].'</em><br />
':''):'').($Information['metadata']?$Information['metadata']:'')));
	}
function e_entry_thumbnail (&$Information, &$FileSystem) {
	if (!$GLOBALS['ThemeConfiguration']['ShowThumbnails']) return ('');
	$Thumbnail = '';
	$ThumbnailPath = EBROWSER_PATH.$GLOBALS['DataDir'].'thumbnails/'.md5 ($Information['path']).'.png';
	if (function_exists ('gd_info') && $Information['type'] == 'image') $ImageSize = getimagesize ('.'.$Information['path']);
	else $ImageSize = 0;
	if (!is_file ($ThumbnailPath) || filemtime ($ThumbnailPath) < filemtime ('.'.$Information['path'])) {
		$Status = 0;
		if ($ImageSize && $ImageSize[0] <= 150 && $ImageSize[1] <= 150) $Status = 2;
		else $Status = e_thumbnail ($Information, $ThumbnailPath, $GLOBALS['ThumbnailSourceSize']);
		}
	else $Status = 1;
	if ($Status) $Thumbnail = '{path}{separator}request&amp;thumbnail='.urlencode ($Information['path']).(($Status == 2)?'&amp;original':'');
	return ($Thumbnail);
	}
function e_entry_emblems (&$Information, &$FileSystem) {
	$Page = '';
	if ($Information['link']) $Page.= '<img src="'.e_icon_path ('link', 'emblems').'" alt="" class="link" />
';
	if ((isset ($Information['locked']) && $Information['locked']) || ($Information['trash'] && $FileSystem->type () != 'trash')) $Page.= '<img src="'.e_icon_path (($Information['trash']?'trash':((defined ('EBROWSER_ADMIN') || defined ('EBROWSER_AREA'))?'un':'').'locked'), 'emblems').'" alt="" class="locked" />
';
	if ($Information['broken']) $Page.= '<img src="'.e_icon_path ('broken', 'emblems').'" alt="" class="broken" />
';
	return ($Page);
	}
function e_entry_actions (&$Information, &$FileSystem) {
	if (!$GLOBALS['ThemeConfiguration']['ShowActions']) return ('');
	$Array = array ();
	if ($FileSystem->type () != 'trash' && $FileSystem->type () != 'tags') {
		if ($Information['type'] == 'archive' && $Information['browseable'] && $FileSystem->type () == 'local') $Information['path'] = 'archive:'.$Information['path'];
		if ($Information['path'] != $GLOBALS['Path'] && $FileSystem->type () != 'bookmarks') $Array[e_i18n ('Preview')] = array (0, 'preview', '{path}'.$Information['path'], 0);
		if (defined ('EBROWSER_ADMIN')) {
			if ($Information['browseable'] && $FileSystem->type () != 'bookmarks') $Array[e_i18n ('Calculate size')] = array (5, 'information', '{path}'.$Information['path'].'{separator}request&amp;size='.urlencode ($Information['path']), 1);
			if ($Information['type'] == 'archive' || ($FileSystem->type () == 'archive' && e_file_archive ($Information['path']))) $Array[e_i18n ('Decompress')] = array (10, 'decompress', '{path}'.$Information['path'].'{separator}request&amp;window=decompress&amp;archivepath='.$Information['path'], 1);
			if ($FileSystem->type () == 'local' && $Information['type'] != 'archive') $Array[e_i18n ('Compress')] = array (10, 'compress', '{path}'.$Information['path'].'{separator}request&amp;window=compress&amp;archivepath='.$Information['path'].'&amp;directory='.(int) $Information['directory'], 1);
			if ($FileSystem->type () != 'bookmarks') {
				$Array[e_i18n ('Edit')] = array (20, 'edit', '{path}'.$Information['path'].'{separator}view=detailed&amp;edit#edit', 0);
				$Array[e_i18n ('Copy')] = array (40, 'copy', '{path}'.$Information['path'].'{separator}request&amp;window=copy', 1);
				}
			if ($FileSystem->type () == 'local' && method_exists ($FileSystem, 'symlink')) $Array[e_i18n ('Symbolic link')] = array (45, 'symlink', '{path}'.$Information['path'].'{separator}request&amp;window=symlink', 1);
			if ($FileSystem->type () != 'bookmarks') $Array[e_i18n ('Tags')] = array (80, 'tags', '{path}'.$Information['path'].'{separator}request&amp;window=tags', 1);
			if (substr_count ($Information['path'], '/') > 1 && $GLOBALS['DB'] && $FileSystem->type () != 'bookmarks') $Array[e_i18n ('Trash')] = array (60, 'trash', '{path}'.e_path_parent ($Information['path']).'{separator}trash&amp;move='.$Information['path'], 0);
			}
		if ($Information['directory']) {
			if ($Information['writeable']) {
				if ($FileSystem->type () != 'bookmarks') {
					if (defined ('EBROWSER_ADMIN')) $Array[e_i18n ('Create')] = array (25, 'create', '{path}'.$Information['path'].'{separator}request&amp;window=create', 1);
					if (defined ('EBROWSER_ADMIN') || ($GLOBALS['DB'] && count ($GLOBALS['DB']->upload_array ($Information['path'])))) $Array[e_i18n ('Send file')] = array (30, 'import', '{path}'.$Information['path'].'{separator}request&amp;window=upload', 1);
					if (defined ('EBROWSER_ADMIN')) $Array[e_i18n ('Rename')] = array (35, 'rename', '{path}'.$Information['path'].'{separator}request&amp;window=rename', 1);
					}
				else if ($Information['path'] == 'bookmarks:/') {
					$Array[e_i18n ('Add')] = array (25, 'create', '{path}{separator}request&amp;window=bookmarksadd', 1);
					$Array[e_i18n ('Import')] = array (30, 'import', 'windowShowHide (\'bookmarksimport\')', 0);
					$Array[e_i18n ('Export')] = array (40, 'export', '{path}{separator}request&amp;bookmarks', 0);
					}
				}
			if ($FileSystem->type () != 'bookmarks') $Array[e_i18n ('Slideshow')] = array (75, 'slideshow', 'javascript:void (0)" onclick="scriptLoad (\'{path}'.$Information['path'].'{separator}request&amp;slideshow='.$Information['path'].';\', 0)', 0);
			}
		if ($GLOBALS['DB'] && $Information['comments']) $Array[e_i18n ('Comments')] = array (70, 'comments', '{path}'.$Information['path'].'{separator}comments#comments', 0);
		}
	else if (defined ('EBROWSER_ADMIN') && $GLOBALS['DB'] && $FileSystem->type () != 'tags') {
		if ($Information['path'] != 'trash:/') $Array[e_i18n ('Retrieve')] = array (50, 'undo', '{path}'.(($FileSystem->type () == 'trash')?'trash:/':e_path_parent ($Information['path'])).'{separator}trash&amp;retrieve='.$Information['path'], 0);
		if ($FileSystem->type () == 'trash') $Array[e_i18n ('Empty trash')] = array (55, 'trashempty', '{path}trash:/{separator}trash&amp;empty', 0);
		}
	if ((defined ('EBROWSER_ADMIN') || $FileSystem->type () == 'bookmarks') && substr_count ($Information['path'], '/') > 1) $Array[e_i18n ('Delete')] = array (65, 'delete', '{path}'.$Information['path'].'{separator}request&amp;window=delete', 1);
	if ($FileSystem->type () != 'bookmarks') $Array[e_i18n ('Add bookmark')] = array (85, 'bookmarks', '{path}'.$Information['path'].'{separator}request&amp;window=bookmarksadd', 1);
	if (defined ('EBROWSER_ADMIN') && $GLOBALS['History'] && $GLOBALS['DB']) $Array[e_i18n ('History')] = array (90, 'history', '{path}'.$Information['path'].'{separator}request&amp;sidebar=history&amp;show&amp;historypath='.$Information['path'], 0);
	$Page = '';
	asort ($Array);
	foreach ($Array as $Key => $Value) $Page.= '<li>
<a href="'.$Value[2].($Value[3]?'&amp;show" onclick="scriptLoad (\''.$Value[2].'\', 0); return false':'').'" tabindex="'.(++$GLOBALS['TabIndex']).'">
<img src="'.e_icon_path ($Value[1], 'miscellaneous').'" alt="'.$Value[1].'" />
'.$Key.'
</a>
</li>
';
	return ($Page);
	}
function e_file_system_model ($Path) {
	$Types = array ('local', 'archive', 'ftp', 'trash', 'bookmarks', 'tags');
	$Type = 'local';
	for ($i = 0, $c = count ($Types); $i < $c; ++$i) {
		if (substr ($Path, 0, (strlen ($Types[$i]) + 1)) == $Types[$i].':') $Type = $Types[$i];
		}
	if ($Type == 'archive') {
		if (strstr ($Path, '@')) $Path = substr ($Path, 0, strpos ($Path, '@'));
		if (function_exists ('finfo_file')) {
			$FileInfo = finfo_open (FILEINFO_MIME | FILEINFO_SYMLINK);
			$MIME = finfo_file ($FileInfo, realpath ($Path));
			finfo_close ($FileInfo);
			}
		else $MIME = '';
		if ($Type = e_file_archive ($Path, $MIME = '')) $Type = 'archive_'.$Type;
		else {
			$Type = 'local';
			$Path = '';
			}
		}
	if ($Type == 'trash' && !defined ('EBROWSER_ADMIN')) $Type = 'local';
	if (!class_exists ('ebrowser_vfs_'.$Type)) require (EBROWSER_PATH.'lib/vfs/'.$Type.'.class.php');
	$Class = 'ebrowser_vfs_'.$Type;
	try {
		$Object = new $Class ($Path);
		}
	catch (Exception $e) {
		if (!class_exists ('ebrowser_vfs_local')) require (EBROWSER_PATH.'lib/vfs/local.class.php');
		$Object = new ebrowser_location_local ('/');
		}
	return ($Object);
	}
function e_file_information ($Array) {
	$Keys = array ('access', 'address', 'broken', 'group', 'link', 'metadata', 'mime', 'owner', 'permissions');
	$Information = array (
	'trash' => 0,
	'description' => '',
	'locked' => 0,
	'password' => '',
	'area' => '',
	'hidden' => 0,
	'preview' => 1,
	'hidesource' => 0,
	'counters' => 0,
	'ratings' => 1,
	'rating' => 0,
	'ratingsamount' => 0,
	'comments' => 0,
	'commentsamount' => 0,
	'views' => 0
	);
	if ($GLOBALS['DB'] && $GLOBALS['DB']->location_array ($Array['path'])) $Information = $GLOBALS['DB']->location_array ($Array['path']);
	if ($Array) $Array += $Information;
	else $Array += array ('time' => 0, 'size' => 0);
	$Array['rating'] = (($Information['rating'] && $Information['ratingsamount'])?round (($Information['rating'] / $Information['ratingsamount']), 2):0);
	if (!isset ($Array['directory'])) $Array['directory'] = (substr ($Array['path'], -1) == '/');
	if (!$Array['directory']) {
		if (!isset ($Array['extension'])) {
			$Array['extension'] = explode ('.', basename ((isset ($Array['link']) && $Array['link'])?$Array['address']:$Array['path']));
			$Array['extension'] = strtoupper (end ($Array['extension']));
			}
		}
	else $Array['extension'] = '';
	$FileType = ($Array['directory']?array ('directory'):e_file_type ($Array['extension'], (isset ($Array['mime'])?$Array['mime']:0)));
	if (!isset ($Array['icon']) || !$Array['icon']) $Array['icon'] = e_icon_path (($Array['path'] == 'trash:/')?'trash':(($Array['path'] == 'tags:/')?'folder-tags':($Array['directory']?'folder':$FileType[0])));
	$Array['type'] = &$FileType[0];
	$Array['information'] = $GLOBALS['LocaleFileTypes'][$FileType[0]].(isset ($FileType[1])?' ('.$FileType[1].')':'');
	$InternalPath = (strstr ($Array['path'], '@')?substr ($Array['path'], (strpos ($Array['path'], '@') + 1)):$Array['path']);
	if (!isset ($Array['name'])) $Array['name'] = basename ($Array['path']);
	$Array['browseable'] = ($Array['directory']?1:e_file_archive ($InternalPath));
	for ($i = 0, $c = count ($Keys); $i < $c; ++$i) {
		if (!isset ($Array[$Keys[$i]])) $Array[$Keys[$i]] = '';
		}
	return ($Array);
	}
function e_file_archive ($Path, $MIME = '') {
	$Array = explode ('.', strtolower ($Path));
	if (end ($Array) == 'tar' || $MIME == 'application/x-tar' || (end ($Array) == 'tgz' && function_exists ('gzopen')) || (isset ($Array[count ($Array) - 2]) && $Array[count ($Array) - 2] == 'tar' && (((end ($Array) == 'gz' || $MIME == 'application/x-gzip') && function_exists ('gzopen')) || ((end ($Array) == 'bz2' || $MIME == 'application/x-bzip2') && function_exists ('bzopen'))))) return ('tar');
	if ((end ($Array) == 'zip' || $MIME == 'application/x-zip') && class_exists ('ZipArchive')) return ('zip');
	if ((end ($Array) == 'rar' || $MIME == 'application/x-rar') && function_exists ('rar_open')) return ('rar');
	return (0);
	}
function e_file_type ($Extension, $MIME = 0) {
	if (substr ($Extension, -1) == '~' || in_array ($Extension, array ('BAK', 'BACKUP'))) return (array ('backup'));
	if ($MIME) {
		if (strstr ($MIME, '(')) {
			$Description = substr ($MIME, 0, (strrpos ($MIME, '(') - 1));
			$MIME = substr ($MIME, (strrpos ($MIME, '(') + 1), -1);
			}
		else $Description = 0;
		if ($Description && stristr ($Description, 'database')) return (array ('database'));
		if ($Description && stristr ($Description, 'sh script')) return (array ('shell', 'SH'));
		if (strstr ($MIME, ';')) $MIME = substr ($MIME, 0, strpos ($MIME, ';'));
		if (strstr ($MIME, '\\')) $MIME = substr ($MIME, 0, strpos ($MIME, '\\'));
		if (strstr ($MIME, ',')) $MIME = substr ($MIME, 0, strpos ($MIME, ','));
		switch ($MIME) {
			case 'application/x-dosexec':
			case 'application/x-executable':
			return (array ('exe'));
			case 'application/x-shellscript':
			return (array ('shell', 'SH'));
			case 'image/vnd.adobe.photoshop':
			return (array ('image', 'PSD'));
			case 'image/vnd.microsoft.icon':
			return (array ('image', 'ICO'));
			case 'video/x-msvideo':
			return (array ('video', 'AVI'));
			case 'application/vnd.rn-realmedia':
			return (array ('video', 'RMVB'));
			case 'audio/mpeg':
			return (array ('audio', 'MP3'));
			case 'audio/vnd.rn-realaudio':
			return (array ('audio', 'RA'));
			case 'application/x-shockwave-flash':
			return (array ('swf'));
			case 'application/pdf':
			return (array ('pdf'));
			case 'application/x-rar':
			return (array ('archive', 'RAR'));
			case 'application/x-zip':
			return (array ('archive', 'ZIP'));
			case 'application/x-bzip2':
			return (array ('archive', 'BZIP2'));
			case 'application/x-gzip':
			return (array ('archive', 'GZIP'));
			case 'application/x-tar':
			return (array ('archive', 'TAR'));
			case 'application/x-lha':
			return (array ('archive', 'LHA'));
			case 'application/x-rpm':
			return (array ('archive', 'RPM'));
			}
		if (strstr ($MIME, '/')) {
			$TmpArray = explode ('/', $MIME);
			if (substr ($TmpArray[1], 0, 4) == 'vnd.') $TmpArray[1] = substr ($TmpArray[1], 4);
			if (substr ($TmpArray[1], 0, 2) == 'x-') $TmpArray[1] = substr ($TmpArray[1], 2);
			if ($TmpArray[0] == 'image') return (array ('image', strtoupper ($TmpArray[1])));
			if ($TmpArray[0] == 'audio') return (array ('audio', strtoupper ($TmpArray[1])));
			if ($TmpArray[0] == 'video') return (array ('video', strtoupper ($TmpArray[1])));
			}
		}
	if ($Extension == 'PDF') return (array ('pdf'));
	if ($Extension == 'EXE') return (array ('exe'));
	if ($Extension == 'SWF') return (array ('swf'));
	if ($Extension == 'URL') return (array ('url'));
	if (in_array ($Extension, array ('HTML', 'HTM', 'SHTML', 'TPL'))) return (array ('html'));
	if (in_array ($Extension, array ('TXT', 'CSS', 'JS', 'SQL', 'LOG', 'INI', 'CSV', 'PO', 'POT', 'README', 'CHANGELOG', 'COPYING', 'CREDITS', 'INSTALL', 'NEWS', 'FAQ', 'LICENCE', 'LICENSE', 'TODO', 'AUTHORS'))) return (array ('text', $Extension));
	if (in_array ($Extension, array ('PHP', 'PHP4', 'PHP5', 'PHTML'))) return (array ('source', 'PHP'));
	if (in_array ($Extension, array ('CPP', 'C', 'CS', 'PY', 'PL', 'PAS', 'H'))) return (array ('source', $Extension));
	if (in_array ($Extension, array ('XML', 'XHTML'))) return (array ('xml', $Extension));
	if (in_array ($Extension, array ('ZIP', 'RAR', 'TAR', 'GZ', 'BZ2', 'TGZ', 'LZF', 'LHA', 'JAR', 'RPM', 'DEB'))) return (array ('archive', $Extension));
	if (in_array ($Extension, array ('AVI', 'MPG', 'MPEG', 'MP4', '3GP', 'RMVB', 'RV', 'MOV', 'WMV'))) {
		if ($Extension == 'MPG') $Extension = 'MPEG';
		return (array ('video', $Extension));
		}
	if (in_array ($Extension, array ('WAV', 'MP3', 'OGG', 'MID', 'MIDI', 'WMA', 'RA'))) {
		if ($Extension == 'MID') $Extension = 'MIDI';
		return (array ('audio', $Extension));
		}
	if (in_array ($Extension, array ('BMP', 'GIF', 'PNG', 'JPG', 'JPEG', 'TIFF', 'PSD', 'ICO', 'MNG', 'KRA'))) {
		if ($Extension == 'JPG') $Extension = 'JPEG';
		return (array ('image', $Extension));
		}
	if (in_array ($Extension, array ('DOC', 'DOCX', 'RTF', 'ODT'))) return (array ('document', $Extension));
	if (in_array ($Extension, array ('XLS', 'XLW', 'SXC', 'ODS'))) return (array ('spreadsheet', $Extension));
	if (in_array ($Extension, array ('PPT', 'PPS', 'SXI', 'ODP'))) return (array ('presentation', $Extension));
	if (in_array ($Extension, array ('TTF', 'PFB', 'GSF', 'PFA'))) return (array ('font', $Extension));
	if (in_array ($Extension, array ('SVG', 'SVGZ'))) return (array ('svg'));
	if (in_array ($Extension, array ('ISO', 'NRG'))) return (array ('cdimage', $Extension));
	if (in_array ($Extension, array ('SH', 'BAT'))) return (array ('shell', $Extension));
	if ($MIME && isset ($TmpArray) && $TmpArray[0] == 'text') return (array ('text', $Extension));
	return (array ('unknown'));
	}
function e_file_permissions ($Permissions) {
	if (($Permissions & 0xC000) == 0xC000) $String = 's';
	else if (($Permissions & 0xA000) == 0xA000) $String = 'l';
	else if (($Permissions & 0x8000) == 0x8000) $String = '-';
	else if (($Permissions & 0x6000) == 0x6000) $String = 'b';
	else if (($Permissions & 0x4000) == 0x4000) $String = 'd';
	else if (($Permissions & 0x2000) == 0x2000) $String = 'c';
	else if (($Permissions & 0x1000) == 0x1000) $String = 'p';
	else $String = 'u';
	$String.= (($Permissions & 0x0100)?'r':'-');
	$String.= (($Permissions & 0x0080)?'w':'-');
	$String.= (($Permissions & 0x0040)?(($Permissions & 0x0800)?'s':'x'):(($Permissions & 0x0800)?'S':'-'));
	$String.= (($Permissions & 0x0020)?'r':'-');
	$String.= (($Permissions & 0x0010)?'w':'-');
	$String.= (($Permissions & 0x0008)?(($Permissions & 0x0400)?'s':'x'):(($Permissions & 0x0400)?'S':'-'));
	$String.= (($Permissions & 0x0004)?'r':'-');
	$String.= (($Permissions & 0x0002)?'w':'-');
	$String.= (($Permissions & 0x0001)?(($Permissions & 0x0200)?'t':'x'):(($Permissions & 0x0200)?'T':'-'));
	return ($String);
	}
function e_file_colorize ($String) {
	$Numbers = '';
	if (strlen ($String) < 100000) {
		$Code = preg_replace ('#<span style="color: \#0000BB">(.*?)</span>#si', '\\1', highlight_string ($String, 1));
		$Code = str_replace (array ('<br />', '<code>', '</code>', '&nbsp;', 'style="color: #FF8000"', 'style="color: #007700"', 'style="color: #DD0000"', "'"), array ("\n", '', '', ' ', 'class="comment"', 'class="other"', 'class="value"', '&#39;'), $Code);
		$Code = str_replace (array ('</span>'."\n".'</span>', '<span style="color: #000000">'."\n".'&lt;?php', '<span style="color: #000000">'), array ('</span>', '&lt;?php'), $Code);
		if (substr_count ($Code, '</span>') == 1 && !substr_count ($Code, '<span')) $Code = str_replace ('</span>', '', $Code);
		$Code = trim ($Code, "\r\n");
		}
	else $Code = htmlspecialchars ($String);
	for ($i = 0, $c = substr_count ($Code, "\n"); $i <= $c; ++$i) $Numbers.= ($i + 1).'
';
	return ('<div id="code">
<pre id="numbers">'.$Numbers.'</pre>
<pre id="blockcode">'.$Code.'
</pre>
</div>
');
	}
function e_text_format ($String) {
	$String = str_replace ("\n", '<br />
', $String);
	$Patterns = array (
	'#\[URL="?(.*?)"?\](.*?)\[/URL\]#sie',
	'#\[URL\](.*?)\[/URL\]#sie',
	'#\[B\](.*?)\[/B\]#si',
	'#\[I\](.*?)\[/I\]#si',
	'#\[U\](.*?)\[/U\]#si',
	'#\[P\](.*?)\[/P\]#si',
	'#\[QUOTE="?(.*?)"?\](.*?)\[/QUOTE]#sie',
	'#\[QUOTE\](.*?)\[/QUOTE]#si',
	'#\[CODE\](.*?)\[/CODE]#sie'
	);
	$Replace = array (
	'\'<a href="\\1" tabindex="\'.(++$GLOBALS[\'TabIndex\']).\'">\\2</a>\'',
	'\'<a href="\\1" tabindex="\'.(++$GLOBALS[\'TabIndex\']).\'">\\1</a>\'',
	'<b>\\1</b>',
	'<i>\\1</i>',
	'<span class="underline">\\1</span>',
	'<p>
\\1
</p>
',
	'\'<p class="quote">
<strong>\'.sprintf ($L[\'quoteauthor\'], \'\\1\').\':</strong><br />
\\2
</p>
\'',
	'<p class="quote">
<strong>'.e_i18n ('Quote').':</strong><br />
\\1
</p>
',
	'code (str_replace (\'<br />\', "\n", \'\\1\'))'
	);
	foreach ($GLOBALS['Emoticons'] as $Key => $Value) $String = str_replace ('['.$Key.']', '<img src="'.EBROWSER_PATH.'share/icons/'.$GLOBALS['ThemeConfiguration']['icons'].'/emoticons/'.$Value.'.png" alt="'.$Key.'" title="'.$Key.'" />', $String);
	return (preg_replace ($Patterns, $Replace, $String));
	}
function e_permissions (&$Information, &$FileSystem) {
	return (defined ('EBROWSER_ADMIN') || (!$Information['hidden'] && (!$Information['locked'] && (!isset ($_SESSION['eBrowser'][$Information['area']]) || $Information['password'] != $_SESSION['eBrowser'][$Information['area']])) && (!$FileSystem->type () == 'local' || realpath ('.'.$Information['path']) != $GLOBALS['BrowserPath'])));
	}
function e_cookie_get ($Key) {
	static $Array;
	$Name = md5 ($GLOBALS['UniqueID'].$Key);
	if (!isset ($_COOKIE[$Name]) || $_COOKIE[$Name] === 0) return (FALSE);
	if (isset ($Array[$Key])) return ($Array[$Key]);
	if (substr ($_COOKIE[$Name], 0, 10) == 'serialize:') $Array[$Key] = substr (stripslashes ($_COOKIE[$Name]), 10);
	else $Array[$Key] = stripslashes ($_COOKIE[$Name]);
	return ($Array[$Key]);
	}
function e_cookie_set ($Key, $Value, $Time = 31356000) {
	$Name = md5 ($GLOBALS['UniqueID'].$Key);
	if ($Value !== NULL) $_COOKIE[$Name] = $Value;
	else if (isset ($_COOKIE[$Name])) unset ($_COOKIE[$Name]);
	setcookie ($Name, (is_array ($Value)?'serialize:'.serialize ($Value):$Value), (($Value !== NULL)?($_SERVER['REQUEST_TIME'] + $Time):0));
	}
function e_language () {
	if (!isset ($_SERVER['HTTP_ACCEPT_LANGUAGE']) || !$_SERVER['HTTP_ACCEPT_LANGUAGE']) return ('?');
	$String = strtolower ($_SERVER['HTTP_ACCEPT_LANGUAGE']);
	return (substr ($String, 0, (strlen ($String) > 2 && $String[2] == '-')?5:2));
	}
function e_locale_load ($Locale) {
	if (!defined ('EBROWSER_GETTEXT')) define ('EBROWSER_GETTEXT', extension_loaded ('gettext'));
	if (EBROWSER_GETTEXT && is_file (EBROWSER_PATH.'locale/'.$Locale.'/LC_MESSAGES/ebrowser.mo')) {
		bindtextdomain ('ebrowser', EBROWSER_PATH.'locale/');
		textdomain ('ebrowser');
		bind_textdomain_codeset ('ebrowser', 'UTF-8');
		}
	else {
		if ($Locale == 'en') return;
		$Path = EBROWSER_PATH.'locale/'.$Locale.'/locale.php';
		if (!is_file ($Path)) return;
		include ($Path);
		if (isset ($GLOBALS['Translation'])) $GLOBALS['Translation'] = array_merge ($L, $GLOBALS['Translation']);
		else $GLOBALS['Translation'] = $L;
		}
	}
function e_i18n ($String) {
	if (EBROWSER_GETTEXT && !isset ($GLOBALS['Translation'][$String])) return (gettext ($String));
	else return (isset ($GLOBALS['Translation'][$String])?$GLOBALS['Translation'][$String]:$String);
	}
function e_string_cut ($String, $Length) {
	if (!$Length) return ($String);
	if (!function_exists ('mb_substr')) return ((strlen ($String) > $Length + 3)?substr_replace ($String, '...', $Length):$String);
	else return ((mb_strwidth ($String, 'UTF-8') > $Length + 3)?mb_substr ($String, 0, $Length, 'UTF-8').'...':$String);
	}
function e_path_parent ($Path) {
	if (substr ($Path, 0, 8) == 'archive:') {
		if (strstr ($Path, '@')) $Path = str_replace ('@', '/@/', $Path);
		else $Path = substr ($Path, 8, -1);
		}
	if (substr ($Path, -1) == '/') $Path = substr ($Path, 0, -1);
	if (strstr ($Path, '/')) $Path = substr ($Path, 0, (strrpos ($Path, '/') + 1));
	else $Path = '/';
	$Path = str_replace ('/@/', '@', $Path);
	if (substr ($Path, -1) == '@') $Path = substr ($Path, 0, -1);
	return ($Path);
	}
function e_size ($Size, $Title = 1) {
	return (($Title?'<span title="'.number_format ($Size, 0, '', ' ').' B">':'').(($Size > 1024)?(($Size > 1048576)?(($Size > 1073741824)?round ($Size / 1073741824, 2).' GB':round ($Size / 1048576, 2).' MB'):round ($Size / 1024, 2).' KB'):(int) $Size.' B').($Title?'</span>':''));
	}
function e_thumbnail (&$Information, $ThumbnailPath, $MaxSourceSize) {
	if (filesize ('.'.$Information['path']) > $MaxSourceSize || filesize ('.'.$Information['path']) < 3 || !is_readable ('.'.$Information['path'])) return (0);
	$Error = 0;
	if ($Information['type'] == 'text' || $Information['type'] == 'source' || $Information['type'] == 'html') {
		$Image = imagecreatetruecolor (150, 150);
		imagefill ($Image, 0, 0, imagecolorallocate ($Image, 250, 250, 250));
		$Text = file ('.'.$Information['path']);
		$Lines = count ($Text);
		if ($Lines > 16) $Lines = 16;
		for ($i = 0; $i < $Lines; ++$i) imagestring ($Image, 1, 0, ($i * 9), rtrim ($Text[$i], "\r\n"), imagecolorallocate ($Image, 0, 0, 0));
		unset ($Text);
		return (e_image_save ($ThumbnailPath, $Image));
		}
	if (class_exists ('Imagick') && in_array ($Information['extension'], array ('PDF', 'JPG', 'JPEG', 'GIF', 'PNG', 'SVG', 'SVGZ', 'TTF'))) {
		try {
			$Image = new Imagick ('.'.$Information['path']);
			$Image->setFormat ('png');
			$Size = $Image->getImageGeometry ();
			$NewSize = e_image_resize ($Size['width'], $Size['height']);
			if (!$Image->thumbnailImage ($NewSize[0], $NewSize[1])) return (0);
			if (is_file ($ThumbnailPath)) unlink ($ThumbnailPath);
			$Image->writeImage ($ThumbnailPath);
			$Image->destroy ();
			chmod ($ThumbnailPath, 0666);
			}
		catch (Exception $e) {
			$Error = 1;
			}
		if (!$Error) return (1);
		}
	if (!in_array ($Information['extension'], array ('JPG', 'JPEG', 'GIF', 'PNG'))) return (0);
	switch ($Information['extension']) {
		case 'PNG':
		$Image = imagecreatefrompng ('.'.$Information['path']);
		break;
		case 'JPG':
		case 'JPEG':
		$Image = imagecreatefromjpeg ('.'.$Information['path']);
		break;
		case 'GIF':
		$Image = imagecreatefromgif ('.'.$Information['path']);
		default:
		return (0);
		}
	$Size = getimagesize ('.'.$Information['path']);
	$NewSize = e_image_resize ($Size[0], $Size[1]);
	$TmpImage = imagecreatetruecolor ($NewSize[0], $NewSize[1]);
	imagecopyresampled ($TmpImage, $Image, 0, 0, 0, 0, $NewSize[0], $NewSize[1], $Size[0], $Size[1]);
	imagedestroy ($Image);
	return (e_image_save ($ThumbnailPath, $TmpImage));
	}
function e_image_save ($Path, $Image) {
	if (is_file ($Path)) unlink ($Path);
	if (!touch ($Path)) return (0);
	chmod ($Path, 0666);
	$Status = imagepng ($Image, $Path);
	imagedestroy ($Image);
	return ((int) $Status);
	}
function e_image_resize ($Width, $Height) {
	if ($Width > $Height) $Size = array (150, (($Height * 150) / $Width));
	else $Size = array ((($Width * 150) / $Height), 150);
	if ($Size[0] < 1) $Size[0] = 1;
	if ($Size[1] < 1) $Size[1] = 1;
	return ($Size);
	}
?>