<?php
class ebrowser_vfs_archive_rar {
private static $Handles;
private static $Information;
private static $Entries;
private $RAR;
private $FileName;
private function path ($Path) {
	if (substr ($Path, 0, 9) == 'archive:/') {
		if (strstr ($Path, '@')) $Path = substr ($Path, (strpos ($Path, '@') + 1));
		else $Path = '';
		}
	return ($Path);
	}
public function __construct ($Path) {
	if (!function_exists ('rar_open')) throw new Exception ();
	$Path = substr ($Path, 9);
	if (strstr ($Path, '@')) $Path = substr ($Path, (strpos ($Path, '@') - 1));
	if (isset (self::$Handles[$Path]) && self::$Handles[$Path] && self::$Handles[$Path]) $this->RAR = &self::$Handles[$Path];
	if (!$this->RAR = rar_open ($Path)) throw new Exception ();
	$this->Writeable = is_writeable ($this->FileName);
	$this->FileName = &$Path;
	self::$Handles[$Path] = &$this->RAR;
	}
public function __destruct () {
	if ($this->RAR) rar_close ($this->RAR);
	unset (self::$Handles[$this->FileName]);
	}
public function refresh () {
	self::$Information = self::$Entries = array ();
	}
public function type () {
	return ('archive');
	}
public function prefix () {
	return ('archive:/'.$this->FileName.'@');
	}
public function size ($Path) {
	$Path = $this->path ($Path);
	if (substr ($Path, -1) != '/') {
		if (!($Information = $this->information ($Path))) return (0);
		return ($Information['size']);
		}
	$Size = 0;
	$Entries = $this->entries ($Path);
	for ($i = 0, $c = count ($Entries); $i < $c; ++$i) $Size += $this->size ($Entries[$i]);
	return ($Size);
	}
public function contents ($Path) {
	$Path = $this->path ($Path);
	if (!$this->RAR = rar_open ($this->FileName)) return (0);
	if (!$Entry = rar_entry_get ($this->RAR, $Path)) return (0);
	if (!$Entry->crc) return (0);
	$TmpPath = EBROWSER_PATH.'data/tmp/rar.tmp';
	$Entry->extract (0, $TmpPath);
	$Contents = file_get_contents ($TmpPath);
	unlink ($TmpPath);
	return ($Contents);
	}
public function exists ($Path) {
	$Path = $this->path ($Path);
	if (!$Path) return (1);
	if (!$this->RAR = rar_open ($this->FileName)) return (0);
	return (rar_entry_get ($this->RAR, $Path) !== FALSE);
	}
public function copy ($From, $To, $FromLocal = 0, $ToLocal = 1) {
	$From = $this->path ($From);
	$To = $this->path ($To);
	if ($From) $Length = strlen ($From);
	$Entries = rar_list ($this->RAR);
	foreach ($Entries as $Entry) {
		if ($From && substr ($Entry->name, $Length) != $From) continue;
		$this->RAR = rar_open ($this->FileName);
		$Object = rar_entry_get ($this->RAR, $Entry->name);
		if ($Object) {
			if (!$Object->extract ($To)) return (0);
			}
		if (is_dir ($To.$Entry->name)) chmod ($To.$Entry->name, 0777);
		}
	return (1);
	}
public function entries ($Path, $Exclude = '') {
	if (isset (self::$Entries[$Path])) return (self::$Entries[$Path]);
	$Path = $this->path ($Path);
	$Entries = rar_list ($this->RAR);
	$Array = array ();
	$Length = strlen ($Path);
	for ($i = 0, $c = count ($Entries); $i < $c; ++$i) {
		if ($Path) {
			$Sub = substr ($Entries[$i]->name, 0, $Length);
			if ($Sub != $Path || $Path == $Entries[$i]->name) continue;
			$Sub = substr ($Entries[$i]->name, $Length);
			}
		else $Sub = &$Entries[$i]->name;
		$Tmp = substr_count ($Sub, '/');
		if ($Tmp > 1 || ($Tmp == 1 && substr ($Sub, -1) != '/')) continue;
		if ($Exclude && preg_match ($Exclude, basename ($Entries[$i]->name))) continue;
		$Array[] = $Entries[$i]->name;
		}
        self::$Entries[$this->prefix ().$Path] = &$Array;
	return ($Array);
	}
public function information ($Path) {
	if (isset (self::$Information[$Path])) return (self::$Information[$Path]);
	$Path = $this->path ($Path);
	if ($Path) {
		if (!$this->RAR = rar_open ($this->FileName)) return (0);
		if (!$Entry = rar_entry_get ($this->RAR, $Path)) return (0);
		$Array = e_file_information (array (
	'name' => basename ($Path),
	'path' => $this->prefix ().$Path.($Entry->crc?'':'/'),
	'readable' => 1,
	'size' => ($Entry->crc?$Entry->unpacked_size:count ($this->entries ($Path))),
	'time' => strtotime ($Entry->file_time),
	'writeable' => 0
	));
		}
	else $Array = e_file_information (array (
	'path' => 'archive:/'.$this->FileName,
	'readable' => is_readable ($this->FileName),
	'size' => filesize ($this->FileName),
	'time' => filemtime ($this->FileName),
	'writeable' => $this->Writeable
	));
        self::$Information[$this->prefix ().$Path] = &$Array;
	return ($Array);
	}
}
?>