<?php
class ebrowser_vfs_archive_tar {
private static $Handles;
private static $Information;
private static $Entries;
private $TAR;
private $FileName;
private $Writeable;
private function path ($Path) {
	if (substr ($Path, 0, 9) == 'archive:/') {
		if (strstr ($Path, '@')) $Path = substr ($Path, (strpos ($Path, '@') + 1));
		else $Path = '';
		}
	return ($Path);
	}
public function __construct ($Path) {
	if (!class_exists ('TAR') && !include (EBROWSER_PATH.'lib/TAR.class.php')) throw new Exception ();
	$this->TAR = new TAR ($Path);
	$Path = substr ($Path, 9);
	if (strstr ($Path, '@')) $Path = substr ($Path, (strpos ($Path, '@') - 1));
	if (isset (self::$Handles[$Path]) && self::$Handles[$Path]) $this->TAR = &self::$Handles[$Path];
	if (!is_file ($Path) && !$this->TAR->save ($Path)) throw new Exception ();
	else if (!$this->TAR->open ($Path)) throw new Exception ();
	$this->FileName = &$Path;
	$this->Writeable = is_writeable ($this->FileName);
	self::$Handles[$Path] = &$this->TAR;
	}
public function __destruct () {
	$this->TAR->save ($this->FileName);
	unset (self::$Handles[$this->FileName]);
	}
public function refresh () {
	self::$Information = self::$Entries = array ();
	}
public function type () {
	return ('archive');
	}
public function prefix () {
	return ('archive:/'.$this->FileName.'@');
	}
public function size ($Path) {
	$Path = $this->path ($Path);
	if (substr ($Path, -1) != '/') {
		if (!($Information = $this->information ($Path))) return (0);
		return ($Information['size']);
		}
	$Size = 0;
	$Entries = $this->entries ($Path);
	for ($i = 0, $c = count ($Entries); $i < $c; ++$i) $Size += $this->size ($Entries[$i]);
	return ($Size);
	}
public function create ($Path, $Directory = 0) {
	$Path = $this->path ($Path);
	return ($this->TAR->entry_add_from_string ($Path, '', 0, $Directory));
	}
public function save ($Path, $Contents) {
	$Path = $this->path ($Path);
	return ($this->TAR->entry_update ($Path, $Contents));
	}
public function contents ($Path) {
	$Path = $this->path ($Path);
	return (implode ('', $this->TAR->entry_get ($Path)));
	}
public function exists ($Path) {
	$Path = $this->path ($Path);
	if (!$Path) return (1);
	return ($this->TAR->entry_exists ($Path));
	}
public function delete ($Path) {
	$Path = $this->path ($Path);
	return ($this->TAR->entry_delete ($Path));
	}
public function rename ($From, $To) {
	$Path = $this->path ($Path);
	return ($this->TAR->entry_rename ($From, $To));
	}
public function copy ($From, $To, $FromLocal = 0, $ToLocal = 0) {
	$From = $this->path ($From);
	$To = $this->path ($To);
	if ($ToLocal) return ($this->TAR->extract ($To, $From));
	else if ($FromLocal) return ($this->TAR->entry_add ($From, $To));
	return (0);
	}
public function entries ($Path, $Exclude = '') {
	if (isset (self::$Entries[$Path])) return (self::$Entries[$Path]);
	$Path = $this->path ($Path);
	$Array = array ();
	if (!($TMPArray = $this->TAR->entries ($Path))) return ($Array);
	$Length = strlen ($Path);
	foreach ($TMPArray as $Key => $Value) {
		if ($Exclude && preg_match ($Exclude, basename ($Key))) continue;
		$Array[] = $Key;
		}
        self::$Entries[$this->prefix ().$Path] = &$Array;
	return ($Array);
	}
public function information ($Path) {
	if (isset (self::$Information[$Path])) return (self::$Information[$Path]);
	$Path = $this->path ($Path);
	if ($Path) {
		if (!$Array = $this->TAR->entry_information ($Path)) return (0);
		$Array = e_file_information (array (
	'group' => $Array['gname'],
	'owner' => $Array['uname'],
	'name' => basename ($Path),
	'path' => $this->prefix ().$Path,
	'permissions' => octdec ($Array['mode']),
	'readable' => 1,
	'size' => (($Array['type'] == 5)?count ($this->entries ($Path)):$Array['size']),
	'time' => $Array['mtime'],
	'writeable' => $this->Writeable
	));
		}
	else $Array = e_file_information (array (
	'path' => 'archive:/'.$this->FileName,
	'readable' => is_readable ($this->FileName),
	'size' => filesize ($this->FileName),
	'time' => filemtime ($this->FileName),
	'writeable' => $this->Writeable
	));
        self::$Information[$this->prefix ().$Path] = &$Array;
	return ($Array);
	}
}
?>