<?php
class ebrowser_vfs_archive_zip {
private static $Handles;
private static $Information;
private static $Entries;
private $ZIP;
private $FileName;
private $Writeable;
private function path ($Path) {
	if (substr ($Path, 0, 9) == 'archive:/') {
		if (strstr ($Path, '@')) $Path = substr ($Path, (strpos ($Path, '@') + 1));
		else $Path = '';
		}
	return ($Path);
	}
private function entries_add ($Path, $Substr) {
	$Path = $this->path ($Path);
	$Array = array ();
	if (!is_dir ($Path) || !is_readable ($Path)) return ($Array);
	if ($Path && substr ($Path, -1) != '/') $Path.= '/';
	if ($Handle = opendir ($Path)) {
		while ($Entry = readdir ($Handle)) {
			if ($Entry == '.' || $Entry == '..') continue;
			if (is_dir ($Path.$Entry)) $this->entries_add ($Path.$Entry.'/', $Substr);
			else $this->ZIP->addFile ($Path.$Entry, substr ($Path.$Entry, $Substr));
			}
		closedir ($Handle);
		}
	}
public function __construct ($Path) {
	if (!class_exists ('ZipArchive')) throw new Exception ();
	$this->ZIP = new ZipArchive ();
	$Path = substr ($Path, 9);
	if (strstr ($Path, '@')) $Path = substr ($Path, (strpos ($Path, '@') - 1));
	if (isset (self::$Handles[$Path]) && self::$Handles[$Path]) $this->ZIP = &self::$Handles[$Path];
	if (!is_file ($Path) && !$this->ZIP->open ($Path, ZIPARCHIVE::CREATE)) throw new Exception ();
	else if (!$this->ZIP->open ($Path)) throw new Exception ();
	$this->FileName = &$Path;
	$this->Writeable = is_writeable ($this->FileName);
	self::$Handles[$Path] = &$this->ZIP;
	}
public function __destruct () {
	if ($this->ZIP) $this->ZIP->close ();
	unset (self::$Handles[$this->FileName]);
	}
public function refresh () {
	self::$Information = self::$Entries = array ();
	}
public function type () {
	return ('archive');
	}
public function prefix () {
	return ('archive:/'.$this->FileName.'@');
	}
public function size ($Path) {
	$Path = $this->path ($Path);
	if (substr ($Path, -1) != '/') {
		if (!($Information = $this->information ($Path))) return (0);
		return ($Information['size']);
		}
	$Size = 0;
	$Entries = $this->entries ($Path);
	for ($i = 0, $c = count ($Entries); $i < $c; ++$i) $Size += $this->size ($Entries[$i]);
	return ($Size);
	}
public function create ($Path, $Directory = 0) {
	$Path = $this->path ($Path);
	if ($Directory) {
		$this->ZIP->addFromString ($Path.'zip.tmp', '');
		$this->ZIP->deleteName ($Path.'zip.tmp');
		return (1);
		}
	else return ($this->ZIP->addFromString ($Path, ''));
	}
public function save ($Path, $Contents) {
	$Path = $this->path ($Path);
	return ($this->ZIP->addFromString ($Path, $Contents));
	}
public function contents ($Path) {
	$Path = $this->path ($Path);
	return ($this->ZIP->getFromName ($Path));
	}
public function exists ($Path) {
	$Path = $this->path ($Path);
	if (!$Path) return (1);
	return ((boolean) $this->ZIP->statName ($Path));
	}
public function delete ($Path) {
	$Path = $this->path ($Path);
	return ($this->ZIP->deleteName ($Path));
	}
public function rename ($From, $To) {
	$Path = $this->path ($Path);
	return ($this->ZIP->renameName ($From, $To));
	}
public function copy ($From, $To) {
	if (e_file_system_model ($To)->type () == 'local') {
		$From = $this->path ($From);
		$To = $this->path ($To);
		if ($From) return ($this->ZIP->extractTo ($To, $From));
		return ($this->ZIP->extractTo ($To));
		}
	else if (e_file_system_model ($From)->type () == 'local') {
		$From = $this->path ($From);
		return ($this->entries_add ($From, strlen ($From)));
		}
	return (0);
	}
public function entries ($Path, $Exclude = '') {
	if (isset (self::$Entries[$Path])) return (self::$Entries[$Path]);
	$Path = $this->path ($Path);
	$Array = array ();
	$Length = strlen ($Path);
	for ($i = 0; $i < $this->ZIP->numFiles; ++$i) {
		$Entry = $this->ZIP->statIndex ($i);
		if ($Path) {
			$Sub = substr ($Entry['name'], 0, $Length);
			if ($Sub != $Path || $Path == $Entry['name']) continue;
			$Sub = substr ($Entry['name'], $Length);
			}
		else $Sub = &$Entry['name'];
		$Tmp = substr_count ($Sub, '/');
		if ($Tmp > 1 || ($Tmp == 1 && substr ($Sub, -1) != '/')) continue;
		if ($Exclude && preg_match ($Exclude, basename ($Entry['name']))) continue;
		$Array[] = &$Entry['name'];
		}
        self::$Entries[$this->prefix ().$Path] = &$Array;
	return ($Array);
	}
public function information ($Path) {
	if (isset (self::$Information[$Path])) return (self::$Information[$Path]);
	$Path = $this->path ($Path);
	if ($Path) {
		if (!$Array = $this->ZIP->statName ($Path)) return (0);
		$Array = e_file_information (array (
	'name' => basename ($Path),
	'path' => $this->prefix ().$Path,
	'readable' => 1,
	'size' => ($Array['crc']?$Array['size']:count ($this->entries ($Path))),
	'time' => $Array['mtime'],
	'writeable' => $this->Writeable
	));
		}
	else $Array = e_file_information (array (
	'path' => 'archive:/'.$this->FileName,
	'readable' => is_readable ($this->FileName),
	'size' => filesize ($this->FileName),
	'time' => filemtime ($this->FileName),
	'writeable' => $this->Writeable
	));
        self::$Information[$this->prefix ().$Path] = &$Array;
	return ($Array);
	}
}
?>