<?php
class ebrowser_vfs_ftp {
private static $Handles;
private static $Information;
private static $Entries;
private $FTP;
private $Host;
private $Port;
private $User;
private function path ($Path) {
	$String = 'ftp:'.$this->User.'@'.$this->Host.':'.$this->Port;
	return ((substr ($Path, 0, strlen ($String)) == $String)?substr ($Path, strlen ($String)):$Path);
	}
public function __construct ($Path) {
	if (!function_exists ('ftp_connect') || !strstr ($Path, '@')) throw new Exception ();
	$Array = explode ('@', substr ($Path, 4, (strpos ($Path, '/') - 3)));
	if (!isset ($Array[1])) throw new Exception ();
	$this->User = $Array[0];
	$this->Host = $Array[1];
	$this->Port = 21;
	if (strstr ($Array[1], ':')) {
		$Array = explode (':', $Array[1]);
		$this->Host = $Array[0];
		$this->Port = substr ($Array[1], 0, strpos ($Array[1], '/'));
		}
	if (isset (self::$Handles[$this->User.'@'.$this->Host]) && self::$Handles[$this->User.'@'.$this->Host]) {
		$this->FTP = &self::$Handles[$this->User.'@'.$this->Host];
		}
	if (!isset ($_SESSION['eBrowser']['ftp'][$this->User.'@'.$this->Host])) throw new Exception ();
	$this->FTP = ftp_connect ($this->Host, $this->Port, 5);
	if (!$this->FTP) throw new Exception ();
	self::$Handles[$this->User.'@'.$this->Host] = &$this->FTP;
	ftp_pasv ($this->FTP, 1);
	if (!$this->FTP || !ftp_login ($this->FTP, $this->User, $_SESSION['eBrowser']['ftp'][$this->User.'@'.$this->Host]['password'])) throw new Exception ();
	}
public function __destruct () {
	if ($this->FTP) ftp_close ($this->FTP);
	unset (self::$Handles[$this->User.'@'.$this->Host]);
	}
public function refresh () {
	self::$Information = self::$Entries = array ();
	}
public function type () {
	return ('ftp');
	}
public function prefix () {
	return ('ftp:'.$this->User.'@'.$this->Host.':'.$this->Port);
	}
public function size ($Path) {
	$Path = $this->path ($Path);
	if (substr ($Path, -1) != '/') {
		if (!($Information = $this->information ($Path))) return (0);
		return ($Information['size']);
		}
	$Size = 0;
	$Entries = $this->entries ($Path);
	for ($i = 0, $c = count ($Entries); $i < $c; ++$i) $Size += $this->size ($Entries[$i]);
	return ($Size);
	}
public function create ($Path, $Directory = 0) {
	$Path = $this->path ($Path);
	if ($Directory) return (ftp_mkdir ($this->FTP, $Path));
	else {
		$Handle = tmpfile ();
		$Status = ftp_fput ($this->FTP, $Path, $Handle, FTP_BINARY);
		fclose ($Handle);
		return ($Status);
		}
	}
public function save ($Path, $Contents) {
	$Path = $this->path ($Path);
	$Handle = tmpfile ();
	fwrite ($Handle, $Contents);
	$Status = ftp_fput ($this->FTP, $Path, $Handle, FTP_BINARY);
	fclose ($Handle);
	return ($Status);
	}
public function contents ($Path) {
	$Path = $this->path ($Path);
	$Handle = tmpfile ();
	$Status = ftp_fget ($this->FTP, $Handle, $Path, FTP_BINARY, 0);
	if ($Status) {
		fseek ($Handle, 0, SEEK_SET);
		$Contents = stream_get_contents ($Handle);
		}
	else $Contents = NULL;
	fclose ($Handle);
	return ($Contents);
	}
public function exists ($Path) {
	$Path = $this->path ($Path);
	return ((boolean) ftp_rawlist ($this->FTP, $Path));
	}
public function chmod ($Path, $Mode) {
	$Path = $this->path ($Path);
	return (ftp_chmod ($this->FTP, $Mode, $Path));
	}
public function delete ($Path) {
	$Path = $this->path ($Path);
	if (substr ($Path, -1) != '/') {
		if (ftp_delete ($This->FTP, $Path)) {
			e_location_update ($this->prefix ().$Path);
			}
		return (0);
		}
	if (ftp_rmdir ($This->FTP, $Path)) {
		e_location_update ($this->prefix ().$Path);
		return (1);
		}
	$this->chmod (substr ($Path, -1), 0777);
	$Entries = $this->entries ($Path);
	for ($i = 0, $c = count ($Entries); $i < $c; ++$i) $this->delete ($Entries[$i]);
	return ($this->delete ($Path));
	}
public function rename ($From, $To) {
	$From = $this->path ($From);
	$To = $this->path ($To);
	return (ftp_rename ($this->FTP, $From, $To));
	}
public function copy ($From, $To) {
	$FromLocal = (e_file_system_model ($From)->type () == 'local');
	$ToLocal = (e_file_system_model ($To)->type () == 'local');
	$From = $this->path ($From);
	$To = $this->path ($To);
	if (!$FromLocal && !$ToLocal) return (ftp_exec ('cp '.htmlspecialchars (str_replace (' ', '', $From)).' '.htmlspecialchars (str_replace (' ', '', $To))));
	else if ($FromLocal) return (ftp_put ($this->FTP, $To, $From, FTP_BINARY));
	else if ($ToLocal) return (ftp_get ($this->FTP, $To, $From, FTP_BINARY));
	return (0);
	}
public function entries ($Path, $Exclude = '') {
	if (isset (self::$Entries[$Path])) return (self::$Entries[$Path]);
	$Path = $this->path ($Path);
	$Array = array ();
	$this->Path = $Path;
	$TmpArray = ftp_rawlist ($this->FTP, $Path);
	if (!$TmpArray) return (0);
	for ($i = 0, $c = count ($TmpArray); $i < $c; ++$i) {
		$Entry = preg_split ('#\s+#', $TmpArray[$i]);
		if ($Entry[8] == '.' || $Entry[8] == '..' || ($Exclude && preg_match ($Exclude, $Entry[8]))) continue;
		$Array[] = $Path.$Entry[8].((substr ($Entry[0], 0, 1) == 'd')?'/':'');
		}
        self::$Entries[$this->prefix ().$Path] = &$Array;
	return ($Array);
	}
public function information ($Path) {
	if (isset (self::$Information[$Path])) return (self::$Information[$Path]);
	$Path = $this->path ($Path);
	if (!$Array = ftp_rawlist ($this->FTP, $Path)) return (0);
	if ($Path != '/') {
		$EntryArray = array ();
		if (count ($Array) > 1) $Array = ftp_rawlist ($this->FTP, e_path_parent ($Path));
		for ($i = 0, $c = count ($Array); $i < $c; ++$i) {
			$Entry = preg_split ('#\s+#', $Array[$i]);
			if (isset ($Entry[8]) && basename ($Entry[8], '/') == basename ($Path, '/')) {
				$EntryArray = &$Entry;
				break;
				}
			}
		if (!$EntryArray) return (0);
		$Size = $EntryArray[(substr ($EntryArray[0], 0, 1) == 'd')?1:4];
		$Time = strtotime ($EntryArray[5].' '.$EntryArray[6].' '.$EntryArray[7]);
		$Array = e_file_information (array (
	'group' => $EntryArray[3],
	'owner' => $EntryArray[2],
	'path' => $this->prefix ().$Path,
	'permissions' => $EntryArray[0],
	'readable' => ($EntryArray[0][7] == 'r' || ($this->User == $EntryArray[2] && $EntryArray[0][1] == 'r')),
	'size' => $Size,
	'time' => $Time,
	'writeable' => ($EntryArray[0][8] == 'r' || ($this->User == $EntryArray[2] && $EntryArray[0][2] == 'r'))
	));
		}
	else $Array = e_file_information (array (
	'group' => 'root',
	'name' => e_i18n ('FTP'),
	'owner' => 'root',
	'path' => $this->prefix ().'/',
	'readable' => 1,
	'size' => count ($Array),
	'time' => 0,
	'writeable' => ($this->User == 'root')
	));
        self::$Information[$this->prefix ().$Path] = &$Array;
	return ($Array);
	}
}
?>